package com.dgtis.dorm.manager.db.dao;

import com.dgtis.dorm.manager.db.domain.ZhllConsultingComplaints;
import org.apache.ibatis.annotations.Param;

import java.time.LocalDate;
import java.util.List;

/**
 * 咨询投诉 数据层
 * 
 * @author ruoyi
 * @date 2019-07-10
 */
public interface ZhllConsultingComplaintsMapper 
{
	/**
     * 查询咨询投诉信息
     * 
     * @param id 咨询投诉ID
     * @return 咨询投诉信息
     */
	public ZhllConsultingComplaints selectZhllConsultingComplaintsById(String id);
	
	/**
     * 查询咨询投诉列表
     * 
     * @param zhllConsultingComplaints 咨询投诉信息
     * @return 咨询投诉集合
     */
	public List<ZhllConsultingComplaints> selectZhllConsultingComplaintsList(ZhllConsultingComplaints zhllConsultingComplaints);
	
	/**
     * 新增咨询投诉
     * 
     * @param zhllConsultingComplaints 咨询投诉信息
     * @return 结果
     */
	public int insertZhllConsultingComplaints(ZhllConsultingComplaints zhllConsultingComplaints);
	
	/**
     * 修改咨询投诉
     * 
     * @param zhllConsultingComplaints 咨询投诉信息
     * @return 结果
     */
	public int updateZhllConsultingComplaints(ZhllConsultingComplaints zhllConsultingComplaints);


	/**
	 * @descption: 根据条件查询List  title和内容是某查询
	 * @param: [zhllConsultingComplaints]
	 * @return: java.util.List<com.dgtis.dorm.manager.db.domain.ZhllConsultingComplaints>
	 * @auther: qxp
	 * @date:19-8-6 09:49
	 */
    List<ZhllConsultingComplaints> queryList(ZhllConsultingComplaints zhllConsultingComplaints);


    List<ZhllConsultingComplaints> queryByTimeListPage(@Param(value="zhllCC")ZhllConsultingComplaints zhllConsultingComplaints,
													   @Param(value="startDate")String startDate, @Param(value="endDate")String endDate);
}