package com.dgtis.dorm.manager.db.dao;

import com.dgtis.dorm.manager.db.domain.ZhllUserMaterial;

import java.util.List;

/**
 * 我的材料 数据层
 * 
 * @author ruoyi
 * @date 2019-07-10
 */
public interface ZhllUserMaterialMapper 
{
	/**
     * 查询我的材料信息
     * 
     * @param id 我的材料ID
     * @return 我的材料信息
     */
	public ZhllUserMaterial selectZhllUserMaterialById(String id);
	
	/**
     * 查询我的材料列表
     * 
     * @param zhllUserMaterial 我的材料信息
     * @return 我的材料集合
     */
	public List<ZhllUserMaterial> selectZhllUserMaterialList(ZhllUserMaterial zhllUserMaterial);
	
	/**
     * 新增我的材料
     * 
     * @param zhllUserMaterial 我的材料信息
     * @return 结果
     */
	public int insertZhllUserMaterial(ZhllUserMaterial zhllUserMaterial);
	
	/**
     * 修改我的材料
     * 
     * @param zhllUserMaterial 我的材料信息
     * @return 结果
     */
	public int updateZhllUserMaterial(ZhllUserMaterial zhllUserMaterial);

	/**
	 * @descption: 根据材料id删除材料
	 * @param:
	 * @return:
	 * @auther: qxp
	 * @date:19-7-10 18:12
	 */
	public Integer deleteById(String id);
}