
const {
  globalData: {
    util: {
      regeneratorRuntime,
      api: {
        reservationDetail,
      },
      request: {
        get
      },
      goHome,
      navigate_auth_native,
    }
  }
} = getApp()
Page({
  async onLoad(option) {
    this.data.option=option
    this.setData({
      msg: await this.getMsg(option)
    })
  },
  async getMsg({ type, id }) {
    switch (type) {
      case 'reservation': //在线预约
        let { reservationNumber, reservationDate, reservationInterval, deptName, _err } = await get(reservationDetail, { id })
        if (_err) return ''
        return `尊敬的用户：您好，您预约的事项已经预约成功，预约号码【${reservationNumber}】,请于${reservationDate} ${reservationInterval == 'AM' ? '上午' : '下午'}准时到达行政服务中心${deptName}窗口进行办理，并注意查收手机短信。`
      case 'interaction'://互动
        return ''
      case 'userinfo'://用户信息
        return ''
      case 'assess'://用户评价
        return ''
      case 'handle'://在线办理
        return '尊敬的用户：您好，您申报的办件已经申报成功，办件编号【' +this.data.option.code+'】请在个人中心 —〉 我的办件中查询办件进度。'

    }
  },
  goHome,
  navigate_auth_native
})